Improved test framework and test for hardlink handling
[rsync/rsync.git] / testsuite / rsync.fns
index b34faa4..2d27a8c 100644 (file)
@@ -53,7 +53,8 @@ hands_setup() {
     # Clean before creation
     rm -rf $FROM
     rm -rf $TO
-    
+
+    [ -d $TMP ] || mkdir $TMP
     [ -d $FROM ] || mkdir $FROM
     [ -d $TO ] || mkdir $TO
 
@@ -72,7 +73,7 @@ hands_setup() {
     mkdir ${FROM}/emptydir
 
     # a hundred lines of text or so
-    rsync_ls_lR ${srcdir} > ${FROM}/filelist
+    rsync_ls_lR "${srcdir}" > ${FROM}/filelist
 
     # This might fail on systems that don't have -n
     echo $ECHO_N "This file has no trailing lf$ECHO_C" > ${FROM}/nolf
@@ -94,6 +95,11 @@ hands_setup() {
 }
 
 
+hands_cleanup() {
+    rm -r "$TMP"
+}
+
+
 
 
 ####################
@@ -112,8 +118,12 @@ makepath () {
        # This will break if $1 contains a space.
        for c in `echo $p | tr '/' ' '`
        do 
-           [ -d "$c" ] || mkdir "$c" || { echo "failed to create $c" >&2; return $? }
-           cd "$c" || return $?
+           if [ -d "$c" ] || mkdir "$c" 
+           then
+               cd "$c" || return $?
+           else
+               echo "failed to create $c" >&2; return $?
+           fi
        done
     )
 }
@@ -125,35 +135,31 @@ makepath () {
 # there are any difference.  If there are, explain them.
 
 checkit() {
-    log=${LOG}
     failed=
-    # the log accumulates all output; we only display it if there 
-    # is a problem.
 
-    echo "Running: \"$1\""  >${log}
-    echo "">>${log}
-    eval "$1"  >>${log} 2>&1
+    # We can just write everything to stdout/stderr, because the
+    # wrapper hides it unless there is a problem.
+
+    echo "Running: \"$1\""  
+    eval "$1" 
     status=$?
     if [ $status != 0 ]; then
        failed="YES";
     fi
 
-    echo "-------------">>${log}
-    echo "check how the files compare with diff:">>${log}
-    echo "">>${log}
-    diff -cr $2 $3 >>${log} 2>&1 || failed=YES
-    echo "-------------">>${log}
-    echo "check how the directory listings compare with diff:">>${log}
-    echo "">>${log}
-    ( cd "$2" && rsync_ls_lR ) > ${TMP}/ls-from 2>>${log}
-    ( cd "$3" && rsync_ls_lR ) > ${TMP}/ls-to  2>>${log}
-    diff -c ${TMP}/ls-from ${TMP}/ls-to >>${log} 2>&1 || failed=YES
+    echo "-------------"
+    echo "check how the files compare with diff:"
+    echo ""
+    diff -cr $2 $3 || failed=YES
+    echo "-------------"
+    echo "check how the directory listings compare with diff:"
+    echo ""
+    ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from 
+    ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to 
+    diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
     if [ -z "${failed}" ] ; then
-       rm $log
        return 0
     else
-       cat ${log}
-       rm ${log}
        return 1
     fi
 }
@@ -200,3 +206,21 @@ EOF
 }
 
 
+build_symlinks() {
+    fromdir="$scratchdir/from"
+    todir="$scratchdir/to"
+    mkdir "$fromdir"
+    date >"$fromdir/referent"
+    ln -s referent "$fromdir/relative"
+    ln -s "$fromdir/referent" "$fromdir/absolute"
+    ln -s nonexistent "$fromdir/dangling"
+    ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
+}
+
+test_fail() {
+    echo "$@" >&2
+    exit 1
+}
+
+# be reproducible
+umask 077
\ No newline at end of file